%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Created_Node_ID = DB_Node_Create(Reference_Coord, Analysis_Coord, Location)

% Счетчик db_Next_Node_Number обновляется вне данной функции после ее вызова
% Если Location - столбец координат, то он предполагается в ГЛОБАЛЬНОЙ системе координат
% Если Location - номер существующего узла, то новый узел будет создан в той же точке

global db_Next_Node_Number;
global ErrCode;

global DB_NODES;
global DB_COORD;

global AST_NODES;
global AST_COORD;

global AT_NODES;
global AT_COORD;

global Cylindrical_CID_R_Tolerance;

global AT_Page_Prealloc_Size;

Created_Node_ID = [];

% Проверка существования в базе узла со следующим номером
if (DB_Node_Exist(db_Next_Node_Number))
    fprintf (1, '\nОшибка функции DB_Node_Create: узел с номером %i уже существует в базе !\n', db_Next_Node_Number);
    ErrCode = -1;
    return;
end

% Проверка существования в базе референсной системы координат
if (~isempty(Reference_Coord))
    if (Reference_Coord ~= 0)
        if (~DB_Coord_Exist(Reference_Coord))
            fprintf (1, '\nОшибка функции DB_Node_Create: референсная система координат с номером %i отсутствует в базе !\n', Reference_Coord);
            ErrCode = -1;
            return;
        end
    end
end

% Проверка существования в базе системы координат анализа
if (~isempty(Analysis_Coord))
    if (Analysis_Coord ~= 0)
        if (~DB_Coord_Exist(Analysis_Coord))
            fprintf (1, '\nОшибка функции DB_Node_Create: система координат анализа с номером %i отсутствует в базе !\n', Analysis_Coord);
            ErrCode = -1;
            return;
        end
    end
end

% Задание референсной системы координат по умолчанию
if (isempty(Reference_Coord))
    Reference_Coord = 0;
end

% Задание системы координат анализа по умолчанию
if (isempty(Analysis_Coord))
    Analysis_Coord = 0;
end

% Проверка существования в базе референсного узла
if (size(Location,1) == 1)
    if (~DB_Node_Exist(Location))
        fprintf (1, '\nОшибка функции DB_Node_Create: референсный узел с номером %i отсутствует в базе !\n', Location);
        ErrCode = -1;
        return;
    end
end

% Заполнение координат создаваемого узла
if (size(Location,1) == 3)
	Node_Global_Location = Location;
else
    Node_Global_Location = DB_NODES{AT_NODES(Location)}.Location;
end

% Выделение памяти
if (isempty(DB_NODES))
    AT_NODES = zeros(AT_Page_Prealloc_Size,1,'uint64');
end
if (db_Next_Node_Number >= size(AT_NODES,1))
    AT_NODES(db_Next_Node_Number + AT_Page_Prealloc_Size,1) = 0;
end

% Следующий индекс в базе
Next_DB_index = size(DB_NODES,1) + 1;

% Создание записи в базе
DB_NODES{Next_DB_index,1}.ID = db_Next_Node_Number;

if (Reference_Coord == 0)
    
    DB_NODES{Next_DB_index,1}.Ref_Location = Node_Global_Location;
    
else
    
    switch DB_COORD{AT_COORD(Reference_Coord)}.type
        
        case 'Rectangular'
            
            Local_XYZ = [DB_COORD{AT_COORD(Reference_Coord)}.e_x, DB_COORD{AT_COORD(Reference_Coord)}.e_y, DB_COORD{AT_COORD(Reference_Coord)}.e_z] \ (Node_Global_Location - DB_COORD{AT_COORD(Reference_Coord)}.origin);
            DB_NODES{Next_DB_index,1}.Ref_Location = Local_XYZ;
            
        case 'Cylindrical'
            
            Local_XYZ = [DB_COORD{AT_COORD(Reference_Coord)}.e_r, DB_COORD{AT_COORD(Reference_Coord)}.e_t, DB_COORD{AT_COORD(Reference_Coord)}.e_z] \ (Node_Global_Location - DB_COORD{AT_COORD(Reference_Coord)}.origin);
            
            DB_NODES{Next_DB_index,1}.Ref_Location = zeros(3,1);
            
            DB_NODES{Next_DB_index,1}.Ref_Location(1) = norm(Local_XYZ(1:2));
            
            if (DB_NODES{Next_DB_index,1}.Ref_Location(1) < Cylindrical_CID_R_Tolerance)
                DB_NODES{Next_DB_index,1}.Ref_Location(2) = 0;
            else
                DB_NODES{Next_DB_index,1}.Ref_Location(2) = acosd(Local_XYZ(1) / DB_NODES{Next_DB_index,1}.Ref_Location(1));
                if (Local_XYZ(2) < 0)
                    DB_NODES{Next_DB_index,1}.Ref_Location(2) = -DB_NODES{Next_DB_index,1}.Ref_Location(2);
                end
            end
            
            DB_NODES{Next_DB_index,1}.Ref_Location(3) = Local_XYZ(3);
            
        otherwise
            
            fprintf (1, '\nОшибка функции DB_Node_Create: тип [%s] системы координат с номером %i не поддерживается в текущей версии программы !\n', DB_COORD{AT_COORD(Reference_Coord)}.type, DB_COORD{AT_COORD(Reference_Coord)}.ID);
            fprintf (1, 'Обратитесь к разработчику для решения данного вопроса.\n');
            ErrCode = -1;
            return;
            
    end
    
end

DB_NODES{Next_DB_index,1}.Location = Node_Global_Location;
DB_NODES{Next_DB_index,1}.Reference_CID = Reference_Coord;
DB_NODES{Next_DB_index,1}.Analysis_CID = Analysis_Coord;

% Создание записи в таблице ассоциативности узлов
AST_NODES{Next_DB_index,1}.Elm_list = [];
AST_NODES{Next_DB_index,1}.MPC_list = [];

% Внесение изменений в таблицу ассоциативности систем координат
if (Reference_Coord ~= 0)
    AST_COORD{AT_COORD(DB_NODES{Next_DB_index}.Reference_CID)}.Node_list = Union_Column(AST_COORD{AT_COORD(DB_NODES{Next_DB_index}.Reference_CID)}.Node_list, db_Next_Node_Number);
end
if ((Analysis_Coord ~= 0) && (Analysis_Coord ~= Reference_Coord))
    AST_COORD{AT_COORD(DB_NODES{Next_DB_index}.Analysis_CID)}.Node_list = Union_Column(AST_COORD{AT_COORD(DB_NODES{Next_DB_index}.Analysis_CID)}.Node_list, db_Next_Node_Number);
end

% Создание ссылки в адресной таблице
AT_NODES(db_Next_Node_Number) = Next_DB_index;

% Номер созданного узла
Created_Node_ID = db_Next_Node_Number;
